<?
/**
* UniReader.class.php
* 
* 
*
* @author		Mark Sievers <msievers@uos.de> 
* @version		$Id: UniReader.class.php,v 1.1 2004/02/18 10:52:10 msievers Exp $
* @access		public
* @modulegroup	core
* @module			
* @package		studip_core
*/

// +---------------------------------------------------------------------------+
// This file is part of Stud.IP
// Unieader.class.php
// This class is an inherit class for reading seminars from the Uni 
// Copyright (C) 2004 Mark Sievers <mark_sievers2000@yahoo.de>
// +---------------------------------------------------------------------------+
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or any later version.
// +---------------------------------------------------------------------------+
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// +---------------------------------------------------------------------------+

class UniReader extends Reader {
    var $all_stors;
    var $starttime;
    var $seminar_ids;

    function UniReader(&$config, $seminar_ids) {
        parent::Reader();
        $this->config = $config;
        $this->seminar_ids = $seminar_ids;
    }

    function getNext() {
        $ret = current($this->seminar_ids);
        next($this->seminar_ids);
        return $ret;
    }

    function getAll() {
        return $this->seminar_ids;
    }

    function setAllSeminars() {
        while ($sem_id = $this->getNext()) {
            $this->setSeminar($sem_id);
        }
    }

    function createSemID() {
        return md5(uniqid("tthelen"));
    }

    function getDatafieldEntries($sem_id) {
        $result = db_query("SELECT datafield_id,content,mkdate,chdate FROM datafields_entries WHERE range_id = '$sem_id'");
        if (!$result->numRows()) {
            return 0;
        }
        return $this->wrapMult($result);
    }
    
    function getSeminarContent($sem_id) {
        $result = db_query("SELECT * FROM seminare WHERE seminar_id = '$sem_id'");
        if (!$result->numRows()) {
            return 0;
        }
        return $result->nextRow("ASSOC");
    }
    
    function getSeminarForum($sem_id) {
        return $result;
    }
    
    function getSeminarDozent($sem_id) {
        $result = db_query("SELECT * FROM seminar_user WHERE seminar_id = '$sem_id' AND status='dozent'");
        if (!$result->numRows()) {
            return 0;
        }
        return $this->wrapMult($result);
    }

    function wrapMult($result) {
        while ($row=$result->nextRow("ASSOC")) {
            $tmp[] = $row;
        }
        return $tmp;
    }

    function getSeminarInst($sem_id) {
        $result = db_query("SELECT * FROM seminar_inst WHERE seminar_id='$sem_id'");
        if (!$result->numRows()) {
            return 0;
		}

		$seminar_inst_array = array();

		while($row = $result->nextRow("ASSOC"))
		{
			$seminar_inst_array []= $row['institut_id'];
		}

		return $seminar_inst_array;
    }

    function getSeminarSemTree($sem_id) {
        $result = db_query("SELECT * FROM seminar_sem_tree WHERE seminar_id = '$sem_id'");
        if (!$result->numRows()) {
            return 0;
        }
        return $this->wrapMult($result);
    }
    
    // wichtig: bei Importierten Veranstaltungen muss die Resource_id in den Metadaten leer sein, sonst gibts Probleme
    function parseMetaDates($sem_content) {
        $metadates = unserialize($sem_content["metadata_dates"]);
        $i = 0;
        foreach ($metadates["turnus_data"] as $key=>$val) {
            $metadates["turnus_data"][$i]["resource_id"] = "";
            $metadates["turnus_data"][$i]["room"] = "";
            $i++;
        }
        $metadates["start_termin"] = -1;    // Den von Hand gesetzten Start-Termin loeschen und    
        $metadates["start_woche"] = 0;      // Ersten Termin automatisch vergeben
        $ser_metadates = serialize($metadates);
        $sem_content["metadata_dates"] = $ser_metadates;
        return $sem_content;
    }
    
    // diese Funktion speichert eine Veranstaltung in die Storage Variable 
    function setSeminar($sem_id) {     
        unset($this->storage);
        $this->storage = new Storage;
        // SeminarContent in Storage speichern
        $sem_content = $this->getSeminarContent($sem_id);  // wir muessen noch das metadates-array bearbeiten
        $sem_content = $this->parseMetaDates($sem_content);
        $this->storage->setSem($sem_content);
        // ab hier Einstellungen, die fuer die Kopie relevant sind
        $this->storage->setAdmissionStartTime(0);
        $this->storage->setAdmissionEndTimeSem(0);
        $this->storage->setAdmissionEndTime(NULL);
        $this->storage->setVisible(0);
        $this->storage->setMakeDate(time());    // mkdate anpassen
        $this->storage->setChangeDate(time());  // chdate anpassen
        $this->storage->setSeminarId(md5(uniqid("Multi-Import")));  // Wir setzen hier schon die neue Sem-Id
        $this->storage->setStartTime($this->config->STARTTIME);

        // SeminarInst speichern
        $sem_inst = $this->getSeminarInst($sem_id);
        $this->storage->setSeminarInst($sem_inst);

        // Dozenten speichern
        $sem_dozent = $this->getSeminarDozent($sem_id);
        foreach ($sem_dozent as $key=>$val) {
            $this->storage->addDozent("",$val["user_id"]);  // Dozent
        }

        // SeminarSemTree speichern (wichtig: an semester_seminar_order denken!!!)
        $sem_tree = $this->getSeminarSemTree($sem_id); 
        foreach ($sem_tree as $key=>$val) {
            $this->storage->addSeminarSemTree("",$val["sem_tree_id"]);
        }
        // generische Datenfeld-Eintraege
        $this->storage->setGenericComplete($this->getDatafieldEntries($sem_id));
        
        
        $this->storage_vector->add($this->storage);     // Speichern des aktuellen Storage-Objektes in den Storage-Vector
    }

    // ab hier einige Methoden zum Parsen fr die Metadaten
    function getDay($string) {
        $day = substr($string,0,2);
        switch ($day) {
            case "Mo":
                $_day = 1;
                break;
            case "Di":
                $_day = 2;
                break;
            case "Mi":
                $_day = 3;
                break;
            case "Do":
                $_day = 4;
                break;
            case "Fr":
                $_day = 5;
                break;
            case "Sa":
                $_day = 6;
                break;
            case "So":
                $_day = 7;
                break;
        }
        return $_day;
    }

    function getStartStunde($string) {
        return 0; 
    }

    function getEndStunde($string) {
        return 0;
    }
    
    function getStartMinute($string) {
        return 0;
    }
    

    function getEndMinute($string) {
        return 0;
    }
    // Ende parse-Funktionen

    function createPW() {
        return md5("myPW");
    }
}


?>
